/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || !const_double_operand (operands[1], E_DFmode)
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !s_register_operand (operands[2], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XEXP (x5, 0);
  if (GET_CODE (x9) != MEM
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != MEM
      || GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != PLUS
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XEXP (x17, 1);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x19 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x19) != SET)
    return -1;
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != PLUS
      || GET_MODE (x20) != E_SImode)
    return -1;
  x21 = XEXP (x20, 1);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x22) != SET)
    return -1;
  x23 = XEXP (x22, 1);
  if (GET_CODE (x23) != PLUS
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XEXP (x23, 1);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern51 (x3, 
E_V8BImode, 
i1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern51 (x3, 
E_V4BImode, 
i2, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x3, 
E_V16BImode, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern55 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_32 (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vpr_register_operand (operands[3], E_V4BImode))
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!s_register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern106 (x3); /* [-1, 2] */
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != XOR
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern117 (x3, 
i1, 
i2); /* [-1, 1] */
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 6;

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern40 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern40 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return 0;

        case E_DImode:
          return 1;

        case E_V16QImode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_int_mve_cde1_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern211 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i3)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern216 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern216 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern234 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern148 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern148 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern148 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (XINT (x2, 1))
    {
    case 33:
      return pattern250 (x1); /* [-1, 1] */

    case 34:
      res = pattern250 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case 37:
      res = pattern250 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case 356:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    case 357:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 8;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case 359:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern267 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern277 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern277 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!s_register_operand (operands[1], E_V4HImode)
              || !reg_or_zero_operand (operands[2], E_V4HImode))
            return -1;
          return 2;

        case E_V4HFmode:
          if (!s_register_operand (operands[1], E_V4HFmode)
              || !reg_or_zero_operand (operands[2], E_V4HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!s_register_operand (operands[1], E_V8HImode)
              || !reg_or_zero_operand (operands[2], E_V8HImode))
            return -1;
          return 4;

        case E_V8HFmode:
          if (!s_register_operand (operands[1], E_V8HFmode)
              || !reg_or_zero_operand (operands[2], E_V8HFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!s_register_operand (operands[1], E_V2SImode)
              || !reg_or_zero_operand (operands[2], E_V2SImode))
            return -1;
          return 6;

        case E_V2SFmode:
          if (!s_register_operand (operands[1], E_V2SFmode)
              || !reg_or_zero_operand (operands[2], E_V2SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!s_register_operand (operands[1], E_V4SImode)
              || !reg_or_zero_operand (operands[2], E_V4SImode))
            return -1;
          return 8;

        case E_V4SFmode:
          if (!s_register_operand (operands[1], E_V4SFmode)
              || !reg_or_zero_operand (operands[2], E_V4SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern337 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 101
      || GET_MODE (x6) != E_SImode
      || pattern335 (x1) != 0)
    return -1;
  return 0;
}

int
pattern345 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 32LL:
      return 0;

    case 16LL:
      if (pattern344 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern354 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern359 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!s_register_operand (x3, i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (!s_register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      return 0;

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[4] = x6;
      if (!shift_operator (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[5] = x7;
      x8 = XEXP (x7, 0);
      operands[6] = x8;
      return 1;

    default:
      return -1;
    }
}

int
pattern389 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern396 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !neon_inv_logic_op2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern402 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode
      || !arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != i1
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != XOR
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !neon_struct_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      return 0;

    case E_V16QImode:
      return 1;

    case E_V4HImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V4HFmode:
      return 6;

    case E_V8HFmode:
      return 7;

    case E_V4BFmode:
      return 8;

    case E_V8BFmode:
      return 9;

    case E_V2SFmode:
      return 10;

    case E_V4SFmode:
      return 11;

    case E_DImode:
      return 12;

    case E_V2DImode:
      return 13;

    default:
      return -1;
    }
}

int
pattern471 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern481 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const_int_vcde2_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !s_register_operand (operands[2], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!s_register_operand (operands[3], E_V4HFmode))
            return -1;
          return 0;

        case E_V8HFmode:
          if (!s_register_operand (operands[3], E_V8HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !s_register_operand (operands[2], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!s_register_operand (operands[3], E_V8HFmode))
            return -1;
          return 2;

        case E_V4HFmode:
          if (!s_register_operand (operands[3], E_V4HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !s_register_operand (operands[2], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!s_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 4;

        case E_V4SFmode:
          if (!s_register_operand (operands[3], E_V4SFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !s_register_operand (operands[2], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!s_register_operand (operands[3], E_V4SFmode))
            return -1;
          return 6;

        case E_V2SFmode:
          if (!s_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern539 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern545 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern544 (x1) != 0)
    return -1;
  return 0;
}

int
pattern555 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_binary_operator (x3, E_SImode))
    return -1;
  operands[5] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[4] = x6;
  return 0;
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x5, 1);
  x12 = XEXP (x11, 0);
  operands[2] = x12;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[3] = x14;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  x16 = XEXP (x15, 0);
  operands[4] = x16;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern611 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern619 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern632 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern631 (x5, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!load_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_hard_general_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!arm_hard_general_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern653 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XEXP (x9, 0);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  x19 = XVECEXP (x1, 0, 4);
  x20 = XEXP (x19, 1);
  x21 = XEXP (x20, 0);
  if (!rtx_equal_p (x21, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != SIGN_EXTEND
          || pattern448 (x1) != 0)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern615 (x1) != 0
          || !
#line 1669 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 27; /* subvsi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (pattern448 (x1) != 0
              || !arm_immediate_operand (operands[1], E_VOIDmode)
              || pattern615 (x1) != 0
              || !
#line 1686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 28; /* subvsi3_imm1 */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!arm_rhs_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern447 (x1, 
E_SImode, 
E_CC_NZmode) != 0
              || !arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x12, 1);
          if (!rtx_equal_p (x14, operands[2])
              || !
#line 2067 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 46; /* subsi3_compare0 */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x7;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_NZmode
              || GET_MODE (x4) != E_CC_NZmode
              || GET_MODE (x5) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x16 = XEXP (x7, 1);
          operands[4] = x16;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          switch (pattern548 (x10, 
MINUS))
            {
            case 0:
              x12 = XEXP (x10, 1);
              x14 = XEXP (x12, 1);
              switch (GET_CODE (x14))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x14, operands[2]))
                    return -1;
                  x11 = XEXP (x10, 0);
                  operands[0] = x11;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[1])
                      || !
#line 9786 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 332; /* *sub_shiftsi_compare0 */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 9802 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 333; /* *sub_shiftsi_compare0_scratch */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != SIGN_EXTEND
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (pattern477 (x9, 
MINUS) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern418 (x10, 
MINUS) != 0
          || GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x4) != E_CC_Vmode
          || GET_MODE (x5) != E_DImode)
        return -1;
      x17 = XEXP (x8, 0);
      operands[1] = x17;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!arm_borrow_operation (operands[4], E_DImode))
        return -1;
      x18 = XEXP (x9, 0);
      x19 = XEXP (x18, 1);
      operands[3] = x19;
      if (!arm_borrow_operation (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x20 = XEXP (x18, 0);
      x21 = XEXP (x20, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      x22 = XEXP (x13, 0);
      if (!rtx_equal_p (x22, operands[1]))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      x23 = XEXP (x6, 1);
      switch (GET_CODE (x23))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x23) != E_DImode)
            return -1;
          x24 = XEXP (x23, 0);
          operands[2] = x24;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x25 = XEXP (x20, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XEXP (x13, 1);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 2185 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 54; /* subvsi3_borrow */

        case CONST_INT:
          operands[2] = x23;
          if (!arm_adcimm_operand (operands[2], E_VOIDmode))
            return -1;
          x25 = XEXP (x20, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XEXP (x13, 1);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 2206 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && INTVAL (operands[2]) == ARM_SIGN_EXTEND (INTVAL (operands[2]))))
            return -1;
          return 55; /* subvsi3_borrow_imm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MEM:
      res = recog_25 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) == USE)
        {
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) == LABEL_REF)
            {
              x6 = XEXP (x2, 1);
              operands[0] = x6;
              if (register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (
#line 2086 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return 1004; /* *thumb1_tablejump */
                }
            }
        }
      break;

    case REG:
    case SUBREG:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x8 = XEXP (x6, 0);
  if (GET_CODE (x8) != UNSPEC
      || pattern287 (x1, 
UNSPEC, 
E_CCmode, 
100) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x4, 0) != 1
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 15
      || GET_MODE (x9) != E_SImode)
    return -1;
  switch (XVECLEN (x8, 0))
    {
    case 1:
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x8, 1))
        {
        case 116:
          if (XINT (x4, 1) != 116)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 741; /* iwmmxt_tandcv2si3 */

            case E_V4HImode:
              if (!
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 742; /* iwmmxt_tandcv4hi3 */

            case E_V8QImode:
              if (!
#line 868 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 743; /* iwmmxt_tandcv8qi3 */

            default:
              return -1;
            }

        case 117:
          if (XINT (x4, 1) != 117)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 744; /* iwmmxt_torcv2si3 */

            case E_V4HImode:
              if (!
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 745; /* iwmmxt_torcv4hi3 */

            case E_V8QImode:
              if (!
#line 878 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 746; /* iwmmxt_torcv8qi3 */

            default:
              return -1;
            }

        case 118:
          if (XINT (x4, 1) != 118)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 747; /* iwmmxt_torvscv2si3 */

            case E_V4HImode:
              if (!
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 748; /* iwmmxt_torvscv4hi3 */

            case E_V8QImode:
              if (!
#line 888 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 749; /* iwmmxt_torvscv8qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x8, 1) != 119)
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XINT (x4, 1) != 119)
        return -1;
      x11 = XVECEXP (x8, 0, 1);
      operands[0] = x11;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (x8))
        {
        case E_V2SImode:
          if (!
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 750; /* iwmmxt_textrcv2si3 */

        case E_V4HImode:
          if (!
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 751; /* iwmmxt_textrcv4hi3 */

        case E_V8QImode:
          if (!
#line 899 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 752; /* iwmmxt_textrcv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      return recog_29 (x1, insn, pnum_clobbers);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      return recog_31 (x1, insn, pnum_clobbers);

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (s_register_operand (operands[0], E_SImode))
        {
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!low_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern296 (x5) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!low_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (low_reg_or_int_operand (operands[2], E_SImode))
        {
          operands[3] = x3;
          if (shift_operator (operands[3], E_SImode)
              && 
#line 1271 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && ((GET_CODE(operands[3]) != ROTATE && GET_CODE(operands[3]) != ROTATERT)
       || REG_P (operands[2]))))
            return 1053; /* *thumb2_shiftsi3_short */
        }
      if (!low_register_operand (operands[2], E_SImode)
          || GET_CODE (x3) != MULT
          || GET_MODE (x3) != E_SImode
          || !
#line 1429 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size && reload_completed))
        return -1;
      return 1061; /* *thumb2_mulsi_short */

    case TRUNCATE:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x8, 1);
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x5, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2515 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 71; /* *smull_high */

        case ZERO_EXTEND:
          if (GET_CODE (x11) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2515 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 72; /* *umull_high */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_28 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x7 = XEXP (x3, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_16 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!arm_comparison_operator (operands[1], E_SImode)
          || pattern255 (x1) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x7;
      if (!arm_add_operand (operands[3], E_SImode)
          || !
#line 9952 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 336; /* *compare_scc */

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x6))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[5] = x6;
          if (!comparison_operator (operands[5], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER
              || pattern450 (x1) != 0
              || pattern575 (x3) != 0
              || !
#line 10767 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 350; /* movcond_addsi */

        default:
          return -1;
        }

    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      return recog_32 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      if (pattern13 (x1) != 0
          || !
#line 4360 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
        return -1;
      return 128; /* arm_qadd_setq_insn */

    case SS_MINUS:
      if (pattern13 (x1) != 0
          || !
#line 4360 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
        return -1;
      return 130; /* arm_qsub_setq_insn */

    case ABS:
      if (pattern14 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x5, 0);
      if (GET_CODE (x12) == REG
          && REGNO (x12) == 100
          && GET_MODE (x12) == E_CCmode)
        {
          if (
#line 5255 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 171; /* *arm_abssi2 */
          if (
#line 117 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return 1011; /* *thumb2_abssi2 */
        }
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 334 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 957; /* *thumb1_abssi2 */

    case NEG:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ABS:
          if (GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) == REG
              && REGNO (x12) == 100
              && GET_MODE (x12) == E_CCmode)
            {
              if (
#line 5319 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return 172; /* *arm_neg_abssi2 */
              if (
#line 170 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1012; /* *thumb2_neg_abssi2 */
            }
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 349 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 958; /* *thumb1_neg_abssi2 */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x6;
          if (!arm_comparison_operator (operands[3], E_VOIDmode)
              || pattern385 (x1) != 0)
            return -1;
          if (
#line 10692 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 349; /* *negscc */
          if (!
#line 899 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
            return -1;
          return 1039; /* *thumb2_negscc */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 100
              || GET_MODE (x12) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 315 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return -1;
              return 955; /* *thumb1_negdi2 */

            case E_SImode:
              if (!low_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !low_register_operand (operands[1], E_SImode)
                  || !
#line 1523 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
                return -1;
              return 1067; /* *thumb2_negsi2_short */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      switch (pattern18 (x2))
        {
        case 0:
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          if (s_register_operand (operands[1], E_SImode))
            {
              if (
#line 8826 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 292; /* *call_value_reg_armv5 */
                }
              if (
#line 8837 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 293; /* *call_value_reg_arm */
                }
            }
          if (
#line 8877 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[1]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
            {
              *pnum_clobbers = 1;
              return 295; /* *call_value_symbol */
            }
          if (register_operand (operands[1], E_SImode))
            {
              if (
#line 1914 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t))
                {
                  *pnum_clobbers = 1;
                  return 994; /* *call_value_reg_thumb1_v5 */
                }
              if (
#line 1940 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t))
                {
                  *pnum_clobbers = 1;
                  return 996; /* *call_value_reg_thumb1 */
                }
            }
          if (
#line 1974 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
            {
              *pnum_clobbers = 1;
              return 998; /* *call_value_insn */
            }
          if (!register_operand (operands[1], E_SImode)
              || !
#line 569 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1028; /* *call_value_reg_thumb2 */

        case 1:
          x6 = XEXP (x3, 0);
          x15 = XVECEXP (x6, 0, 0);
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) == REG
              && REGNO (x16) == 4
              && GET_MODE (x16) == E_SImode)
            {
              x7 = XEXP (x3, 1);
              operands[1] = x7;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (
#line 1928 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse))
                {
                  *pnum_clobbers = 1;
                  return 995; /* *nonsecure_call_value_reg_thumb1_v5 */
                }
            }
          operands[1] = x16;
          if (register_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              if (
#line 582 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                {
                  *pnum_clobbers = 1;
                  return 1029; /* *nonsecure_call_value_reg_thumb2_fpcxt */
                }
            }
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 4
              || GET_MODE (x16) != E_SImode)
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (!
#line 595 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
            return -1;
          *pnum_clobbers = 1;
          return 1030; /* *nonsecure_call_value_reg_thumb2 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern296 (x5) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x3, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11839 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 382; /* *sign_extract_onebit */

    case NOT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern256 (x5) != 0
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x6, 2);
          operands[2] = x18;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 11857 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 383; /* *not_signextract_onebit */

        case REG:
          operands[1] = x6;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern256 (x5) != 0
              || !low_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 1512 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1066; /* *thumb2_one_cmplsi2_short */

        case AND:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern295 (x5, pnum_clobbers) != 0)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          x19 = XEXP (x5, 1);
          x20 = XVECEXP (x19, 0, 2);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern530 (x1))
            {
            case 0:
              if (!
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3161; /* atomic_nand_fetchqi */

            case 1:
              if (!
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3162; /* atomic_nand_fetchhi */

            case 2:
              if (!
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3163; /* atomic_nand_fetchsi */

            case 3:
              if (!
#line 483 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3164; /* atomic_nand_fetchdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (GET_CODE (x3))
        {
        case MEM:
          res = recog_23 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_27 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (memory_operand (operands[2], E_SImode))
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == SET)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x12 = XEXP (x5, 0);
                  operands[1] = x12;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x19 = XEXP (x5, 1);
                      operands[3] = x19;
                      if (memory_operand (operands[3], E_SImode)
                          && 
#line 164 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, true)))
                        return 435; /* *arm_ldrd */
                    }
                }
            }
        }
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[3] = x12;
      if (!memory_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 184 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, false)))
        return -1;
      return 436; /* *arm_strd */

    case CONST_DOUBLE:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 2142 "../../gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !arm_const_double_rtx (operands[1])
   && !(TARGET_VFP_DOUBLE && vfp3_const_double_rtx (operands[1]))))
            return -1;
          return 927; /* no_literal_pool_df_immediate */

        case 1:
          if (!
#line 2169 "../../gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !vfp3_const_double_rtx (operands[1])))
            return -1;
          return 928; /* no_literal_pool_sf_immediate */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 446 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 963; /* thumb1_extendhisi2 */

    case CONST_INT:
      operands[1] = x3;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!low_register_operand (operands[0], E_QImode)
              || !const_int_operand (operands[1], E_QImode)
              || !
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1054; /* *thumb2_movqi_shortim */

        case E_HImode:
          if (!low_register_operand (operands[0], E_HImode)
              || !const_int_operand (operands[1], E_HImode)
              || !
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1055; /* *thumb2_movhi_shortim */

        case E_SImode:
          if (!low_register_operand (operands[0], E_SImode)
              || !const_int_operand (operands[1], E_SImode)
              || !
#line 1289 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1056; /* *thumb2_movsi_shortim */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_30 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern92 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !s_register_operand (operands[2], E_V8HImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4912; /* mve_vldrq_gather_shifted_offset_v8hi */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !s_register_operand (operands[2], E_V4SImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4913; /* mve_vldrq_gather_shifted_offset_v4si */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !s_register_operand (operands[2], E_V8HImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4914; /* mve_vldrq_gather_shifted_offset_v8hf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !s_register_operand (operands[2], E_V4SImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4915; /* mve_vldrq_gather_shifted_offset_v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3581 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4916; /* mve_vldrq_gather_shifted_offset_v2di */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern391 (x3, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4825; /* mve_vstrq_p_v16qi */

    case E_V8HImode:
      if (pattern391 (x3, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4826; /* mve_vstrq_p_v8hi */

    case E_V4SImode:
      if (pattern391 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4827; /* mve_vstrq_p_v4si */

    case E_V8HFmode:
      if (pattern391 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4828; /* mve_vstrq_p_v8hf */

    case E_V4SFmode:
      if (pattern391 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3155 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4829; /* mve_vstrq_p_v4sf */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2465; /* neon_vsri_nv8qi */

    case 1:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2466; /* neon_vsri_nv16qi */

    case 2:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2467; /* neon_vsri_nv4hi */

    case 3:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2468; /* neon_vsri_nv8hi */

    case 4:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2469; /* neon_vsri_nv2si */

    case 5:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2470; /* neon_vsri_nv4si */

    case 6:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2471; /* neon_vsri_ndi */

    case 7:
      if (!
#line 4644 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2472; /* neon_vsri_nv2di */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern44 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2613; /* neon_vld1x4qbv16qi */

    case 1:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2614; /* neon_vld1x4qbv8hi */

    case 2:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2615; /* neon_vld1x4qbv8hf */

    case 3:
      if (!(
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2616; /* neon_vld1x4qbv8bf */

    case 4:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2617; /* neon_vld1x4qbv4si */

    case 5:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2618; /* neon_vld1x4qbv4sf */

    case 6:
      if (!
#line 5111 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2619; /* neon_vld1x4qbv2di */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern42 (x1))
    {
    case 0:
      if (!
#line 3954 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2190; /* neon_vqdmulh_lanev8hi */

    case 1:
      if (!
#line 3954 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2192; /* neon_vqdmulh_lanev4si */

    case 2:
      if (!
#line 3968 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2194; /* neon_vqdmulh_lanev4hi */

    case 3:
      if (!
#line 3968 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2196; /* neon_vqdmulh_lanev2si */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 6680 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3029; /* neon_vbfcvtv4sfv4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 6680 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3030; /* neon_vbfcvtv4sfv8bf */

    case E_BFmode:
      if (!register_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 6699 "../../gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3032; /* neon_vbfcvtsf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          if (!register_operand (operands[1], E_V4BFmode)
              || !
#line 6708 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3033; /* neon_vbfcvtv4bf */

        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !
#line 6708 "../../gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3034; /* neon_vbfcvtv8bf */

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_BFmode)
          || !
#line 6749 "../../gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3036; /* neon_vbfcvtbf_cvtmodev2si */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 6749 "../../gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3037; /* neon_vbfcvtbf_cvtmodesf */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      if (!vpr_register_operand (operands[0], E_V16BImode)
          || GET_MODE (x3) != E_V16BImode
          || !
#line 465 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3355; /* mve_vctp8qv16bi */

    case E_V8BImode:
      if (!vpr_register_operand (operands[0], E_V8BImode)
          || GET_MODE (x3) != E_V8BImode
          || !
#line 465 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3356; /* mve_vctp16qv8bi */

    case E_V4BImode:
      if (!vpr_register_operand (operands[0], E_V4BImode)
          || GET_MODE (x3) != E_V4BImode
          || !
#line 465 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3357; /* mve_vctp32qv4bi */

    case E_V2QImode:
      if (!vpr_register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !
#line 465 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3358; /* mve_vctp64qv2qi */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern105 (x1))
    {
    case 0:
      if (!
#line 3718 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2109; /* neon_vcvtuv2sf */

    case 1:
      if (!
#line 3718 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2111; /* neon_vcvtuv4sf */

    case 2:
      if (!
#line 3727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2113; /* neon_vcvtuv2si */

    case 3:
      if (!
#line 3727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2115; /* neon_vcvtuv4si */

    case 4:
      if (!
#line 3756 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2119; /* neon_vcvtuv4hi */

    case 5:
      if (!
#line 3756 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2121; /* neon_vcvtuv8hi */

    case 6:
      if (!
#line 3767 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2123; /* neon_vcvtuv8hf */

    case 7:
      if (!
#line 3767 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2125; /* neon_vcvtuv4hf */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 852 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1341; /* neon_vrsqrtev8hf */

    case 1:
      if (!
#line 852 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1342; /* neon_vrsqrtev4hf */

    case 2:
      if (!
#line 3202 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2032; /* neon_vrsqrtev2si */

    case 3:
      if (!
#line 3202 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2033; /* neon_vrsqrtev2sf */

    case 4:
      if (!
#line 3202 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2034; /* neon_vrsqrtev4si */

    case 5:
      if (!
#line 3202 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2035; /* neon_vrsqrtev4sf */

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern149 (x1))
    {
    case 0:
      if (!(
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return -1;
      return 1928; /* neon_vcadd90v4hf */

    case 1:
      if (register_operand (operands[0], E_V8HFmode)
          && register_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && (
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return 1930; /* neon_vcadd90v8hf */
      if (!s_register_operand (operands[0], E_V8HFmode)
          || !s_register_operand (operands[1], E_V8HFmode)
          || !s_register_operand (operands[2], E_V8HFmode)
          || !
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3738; /* mve_vcaddq_rot90_fv8hf */

    case 2:
      if (!
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return -1;
      return 1932; /* neon_vcadd90v2sf */

    case 3:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 2880 "../../gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return 1934; /* neon_vcadd90v4sf */
      if (!s_register_operand (operands[0], E_V4SFmode)
          || !s_register_operand (operands[1], E_V4SFmode)
          || !s_register_operand (operands[2], E_V4SFmode)
          || !
#line 1209 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3744; /* mve_vcaddq_rot90_fv4sf */

    case 4:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3562; /* mve_vcaddq_rot90_v16qi */

    case 5:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3566; /* mve_vcaddq_rot90_v8hi */

    case 6:
      if (!
#line 830 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3570; /* mve_vcaddq_rot90_v4si */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern157 (x1))
    {
    case 0:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2716; /* neon_vst1x3qbv8qi */

    case 1:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2717; /* neon_vst1x3qbv16qi */

    case 2:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2718; /* neon_vst1x3qbv4hi */

    case 3:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2719; /* neon_vst1x3qbv8hi */

    case 4:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2720; /* neon_vst1x3qbv2si */

    case 5:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2721; /* neon_vst1x3qbv4si */

    case 6:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2722; /* neon_vst1x3qbv4hf */

    case 7:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2723; /* neon_vst1x3qbv8hf */

    case 8:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2724; /* neon_vst1x3qbv4bf */

    case 9:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2725; /* neon_vst1x3qbv8bf */

    case 10:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2726; /* neon_vst1x3qbv2sf */

    case 11:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2727; /* neon_vst1x3qbv4sf */

    case 12:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2728; /* neon_vst1x3qbdi */

    case 13:
      if (!
#line 5287 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2729; /* neon_vst1x3qbv2di */

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern370 (x3, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4841; /* mve_vldrq_z_v16qi */

    case E_V8HImode:
      if (pattern370 (x3, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4842; /* mve_vldrq_z_v8hi */

    case E_V4SImode:
      if (pattern370 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4843; /* mve_vldrq_z_v4si */

    case E_V8HFmode:
      if (pattern370 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4844; /* mve_vldrq_z_v8hf */

    case E_V4SFmode:
      if (pattern370 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3252 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4845; /* mve_vldrq_z_v4sf */

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2403; /* neon_vqshl_s_nv8qi */

    case 1:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2405; /* neon_vqshl_s_nv16qi */

    case 2:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2407; /* neon_vqshl_s_nv4hi */

    case 3:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2409; /* neon_vqshl_s_nv8hi */

    case 4:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2411; /* neon_vqshl_s_nv2si */

    case 5:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2413; /* neon_vqshl_s_nv4si */

    case 6:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2415; /* neon_vqshl_s_ndi */

    case 7:
      if (!
#line 4588 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2417; /* neon_vqshl_s_nv2di */

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2307; /* neon_vqshlsv8qi */

    case 1:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2311; /* neon_vqshlsv16qi */

    case 2:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2315; /* neon_vqshlsv4hi */

    case 3:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2319; /* neon_vqshlsv8hi */

    case 4:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2323; /* neon_vqshlsv2si */

    case 5:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2327; /* neon_vqshlsv4si */

    case 6:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2331; /* neon_vqshlsdi */

    case 7:
      if (!
#line 4509 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2335; /* neon_vqshlsv2di */

    default:
      return -1;
    }
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1633; /* neon_vqsubsv8qi */

    case 1:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1635; /* neon_vqsubsv16qi */

    case 2:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1637; /* neon_vqsubsv4hi */

    case 3:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1639; /* neon_vqsubsv8hi */

    case 4:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1641; /* neon_vqsubsv2si */

    case 5:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1643; /* neon_vqsubsv4si */

    case 6:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1645; /* neon_vqsubsdi */

    case 7:
      if (!
#line 2293 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1647; /* neon_vqsubsv2di */

    default:
      return -1;
    }
}

 int
recog_193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1, 
E_OImode, 
E_XImode))
    {
    case 0:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2606; /* neon_vld1x4qav16qi */

    case 1:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2607; /* neon_vld1x4qav8hi */

    case 2:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2608; /* neon_vld1x4qav8hf */

    case 3:
      if (!(
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2609; /* neon_vld1x4qav8bf */

    case 4:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2610; /* neon_vld1x4qav4si */

    case 5:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2611; /* neon_vld1x4qav4sf */

    case 6:
      if (!
#line 5093 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2612; /* neon_vld1x4qav2di */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2879; /* neon_vst3qbv16qi */

    case 1:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2880; /* neon_vst3qbv8hi */

    case 2:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2881; /* neon_vst3qbv8hf */

    case 3:
      if (!(
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2882; /* neon_vst3qbv8bf */

    case 4:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2883; /* neon_vst3qbv4si */

    case 5:
      if (!
#line 5887 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2884; /* neon_vst3qbv4sf */

    default:
      return -1;
    }
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1787; /* neon_vabdsv8qi */

    case 1:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1789; /* neon_vabdsv16qi */

    case 2:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1791; /* neon_vabdsv4hi */

    case 3:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1793; /* neon_vabdsv8hi */

    case 4:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1795; /* neon_vabdsv2si */

    case 5:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1797; /* neon_vabdsv4si */

    default:
      return -1;
    }
}

 int
recog_223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 385; /* stack_tie */
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1758; /* neon_vcagtv2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1762; /* neon_vcagtv4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1774; /* neon_vcagtv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1778; /* neon_vcagtv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern132 (x1))
    {
    case 0:
      if (!
#line 1376 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1440; /* neon_vpsminv8qi */

    case 1:
      if (!
#line 1376 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1441; /* neon_vpsminv4hi */

    case 2:
      if (!
#line 1376 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1442; /* neon_vpsminv2si */

    case 3:
      if (!
#line 1376 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1443; /* neon_vpsminv2sf */

    default:
      return -1;
    }
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern231 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      switch (pattern533 ())
        {
        case 0:
          if (!
#line 3699 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
            return -1;
          return 4932; /* mve_vstrq_scatter_shifted_offset_p_v8hi */

        case 1:
          if (!
#line 3699 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
            return -1;
          return 4934; /* mve_vstrq_scatter_shifted_offset_p_v8hf */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      switch (pattern552 ())
        {
        case 0:
          if (!
#line 3699 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4933; /* mve_vstrq_scatter_shifted_offset_p_v4si */

        case 1:
          if (!
#line 3699 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4935; /* mve_vstrq_scatter_shifted_offset_p_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !vpr_register_operand (operands[3], E_V2QImode)
          || !
#line 3699 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4936; /* mve_vstrq_scatter_shifted_offset_p_v2di */

    default:
      return -1;
    }
}

 int
recog_258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (pattern213 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3070 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4798; /* mve_vbrsrq_m_n_fv8hf */

    case E_V4SFmode:
      if (pattern213 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3070 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4799; /* mve_vbrsrq_m_n_fv4sf */

    default:
      return -1;
    }
}

 int
recog_267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[3] = x5;
      if (const_int_operand (operands[3], E_SImode)
          && pattern461 (x1) == 0)
        {
          x6 = XEXP (x2, 1);
          operands[4] = x6;
          if (arm_not_operand (operands[4], E_SImode)
              && 
#line 3182 "../../gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
            {
              *pnum_clobbers = 1;
              return 96; /* *ite_ne_zeroextractsi */
            }
        }
      if (XWINT (x5, 0) != 0LL
          || pattern461 (x1) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!arm_not_operand (operands[3], E_SImode)
          || !
#line 3221 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
        return -1;
      *pnum_clobbers = 1;
      return 97; /* *ite_ne_zeroextractsi_shifted */

    case EQ:
      x7 = XEXP (x3, 1);
      if (pattern317 (x7, 
41) != 0)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != PC)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!guard_addr_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x6, 0);
      operands[2] = x12;
      *pnum_clobbers = 3;
      return 310; /* *stack_protect_combined_test_insn */

    default:
      return -1;
    }
}

 int
recog_274 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers != NULL)
        {
          res = recog_271 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (cc_register (x4, E_VOIDmode))
        {
          res = recog_272 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_273 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[6] = x4;
      if (!cc_register (operands[6], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      operands[4] = x3;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          operands[5] = x7;
          if (!shiftable_operator (operands[5], E_SImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[3] = x9;
          if (!arm_rhs_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x2, 2);
          operands[1] = x10;
          if (!arm_rhs_operand (operands[1], E_SImode)
              || !
#line 11036 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 359; /* *if_arith_move */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (!arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x2, 2);
          if (!shiftable_operator (x10, E_SImode))
            return -1;
          operands[5] = x10;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_rhs_operand (operands[3], E_SImode)
              || !
#line 11103 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 361; /* *if_move_arith */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x10 = XEXP (x2, 2);
      if (GET_CODE (x10) != PC)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      operands[3] = x3;
      x13 = XEXP (x4, 0);
      operands[1] = x13;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x14 = XEXP (x4, 1);
      operands[2] = x14;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!
#line 1661 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[3]) == EQ
       || GET_CODE (operands[3]) == NE
       || GET_CODE (operands[3]) == GE
       || GET_CODE (operands[3]) == LT)))
        return -1;
      *pnum_clobbers = 1;
      return 983; /* *addsi3_cbranch_scratch */

    default:
      return -1;
    }
}

 int
recog_280 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (XWINT (x4, 0) == 0LL
              && s_register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && s_register_operand (operands[1], E_SImode)
              && 
#line 4127 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 120; /* *smin_0 */
          break;

        case REG:
        case SUBREG:
          switch (pattern348 (x2))
            {
            case 0:
              if (register_operand (operands[0], E_V2SImode)
                  && register_operand (operands[1], E_V2SImode)
                  && register_operand (operands[2], E_V2SImode)
                  && 
#line 923 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 609; /* *sminv2si3_iwmmxt */
              if (s_register_operand (operands[0], E_V2SImode)
                  && s_register_operand (operands[1], E_V2SImode)
                  && s_register_operand (operands[2], E_V2SImode)
                  && 
#line 879 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1359; /* *sminv2si3_neon */
              break;

            case 1:
              if (register_operand (operands[0], E_V4HImode)
                  && register_operand (operands[1], E_V4HImode)
                  && register_operand (operands[2], E_V4HImode)
                  && 
#line 923 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 610; /* *sminv4hi3_iwmmxt */
              if (s_register_operand (operands[0], E_V4HImode)
                  && s_register_operand (operands[1], E_V4HImode)
                  && s_register_operand (operands[2], E_V4HImode)
                  && 
#line 879 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1357; /* *sminv4hi3_neon */
              break;

            case 2:
              if (register_operand (operands[0], E_V8QImode)
                  && register_operand (operands[1], E_V8QImode)
                  && register_operand (operands[2], E_V8QImode)
                  && 
#line 923 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 611; /* *sminv8qi3_iwmmxt */
              if (s_register_operand (operands[0], E_V8QImode)
                  && s_register_operand (operands[1], E_V8QImode)
                  && s_register_operand (operands[2], E_V8QImode)
                  && 
#line 879 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1355; /* *sminv8qi3_neon */
              break;

            case 3:
              if (
#line 2080 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
                return 917; /* sminsf3 */
              break;

            case 4:
              if ((
#line 2080 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return 918; /* smindf3 */
              break;

            case 5:
              if (
#line 879 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1356; /* *sminv16qi3_neon */
              if (
#line 916 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3615; /* mve_vminq_sv16qi */
              break;

            case 6:
              if (
#line 879 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1358; /* *sminv8hi3_neon */
              if (
#line 916 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3619; /* mve_vminq_sv8hi */
              break;

            case 7:
              if (
#line 879 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1360; /* *sminv4si3_neon */
              if (
#line 916 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return 3623; /* mve_vminq_sv4si */
              break;

            case 8:
              if (
#line 879 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1361; /* *sminv2sf3_neon */
              break;

            case 9:
              if (
#line 879 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1362; /* *sminv4sf3_neon */
              if (
#line 1341 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return 3797; /* mve_vminnmq_fv4sf */
              break;

            case 10:
              if (
#line 1341 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return 3795; /* mve_vminnmq_fv8hf */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || pattern349 (x2) != 0
          || !
#line 4138 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 121; /* *arm_smin_insn */

    case SMAX:
      switch (pattern270 (x2))
        {
        case 0:
          if (!
#line 4477 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL)))
            return -1;
          return 133; /* satsi_smin */

        case 1:
          if (!
#line 4503 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL)))
            return -1;
          return 137; /* *satsi_smin_shift */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern271 (x2))
        {
        case 0:
          if (!
#line 1129 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1417; /* quad_halves_sminv4si */

        case 1:
          if (!
#line 1142 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 1422; /* quad_halves_sminv4sf */

        case 2:
          if (!
#line 1157 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1425; /* quad_halves_sminv8hi */

        case 3:
          if (!
#line 1176 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1430; /* quad_halves_sminv16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[2] = x4;
      if (arm_borrow_operation (operands[2], E_SImode)
          && s_register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && s_register_operand (operands[1], E_SImode)
          && 
#line 1817 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return 40; /* *subsi3_carryin_const0 */
      if (pnum_clobbers == NULL)
        return -1;
      operands[4] = x4;
      if (!arm_comparison_operator (operands[4], E_SImode)
          || pattern432 (x2) != 0)
        return -1;
      if (
#line 10136 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        {
          *pnum_clobbers = 1;
          return 339; /* *cond_sub */
        }
      if (!
#line 868 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1038; /* *thumb2_cond_sub */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !reg_or_int_operand (operands[1], E_SImode)
              || !reg_or_int_operand (operands[2], E_SImode)
              || !
#line 2020 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 45; /* *arm_subsi3_insn */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 411 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 561; /* *subv2si3_iwmmxt */
          if (!s_register_operand (operands[0], E_V2SImode)
              || !s_register_operand (operands[1], E_V2SImode)
              || !s_register_operand (operands[2], E_V2SImode)
              || !
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
            return -1;
          return 1174; /* *subv2si3_neon */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 411 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 562; /* *subv4hi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V4HImode)
              || !s_register_operand (operands[1], E_V4HImode)
              || !s_register_operand (operands[2], E_V4HImode)
              || !
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
            return -1;
          return 1172; /* *subv4hi3_neon */

        case E_V8QImode:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 411 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 563; /* *subv8qi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V8QImode)
              || !s_register_operand (operands[1], E_V8QImode)
              || !s_register_operand (operands[2], E_V8QImode)
              || !
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
            return -1;
          return 1170; /* *subv8qi3_neon */

        case E_HFmode:
          if (pattern1 (x2, 
E_HFmode) != 0
              || !
#line 1028 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 798; /* subhf3 */

        case E_SFmode:
          if (pattern1 (x2, 
E_SFmode) != 0
              || !
#line 1038 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 799; /* *subsf3_vfp */

        case E_DFmode:
          if (pattern1 (x2, 
E_DFmode) != 0
              || !
#line 1048 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 800; /* *subdf3_vfp */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern347 (x2, 
E_DImode) != 0
              || !
#line 132 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          *pnum_clobbers = 1;
          return 943; /* *thumb_subdi3 */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
            return 1171; /* *subv16qi3_neon */
          if (!
#line 991 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3671; /* mve_vsubqv16qi */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
            return 1173; /* *subv8hi3_neon */
          if (!
#line 991 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3674; /* mve_vsubqv8hi */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
            return 1175; /* *subv4si3_neon */
          if (!
#line 991 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3677; /* mve_vsubqv4si */

        case E_V4HFmode:
          if (pattern1 (x2, 
E_V4HFmode) != 0
              || !
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH))
            return -1;
          return 1176; /* *subv4hf3_neon */

        case E_V8HFmode:
          if (pattern1 (x2, 
E_V8HFmode) != 0)
            return -1;
          if (
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH))
            return 1177; /* *subv8hf3_neon */
          if (!
#line 1399 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3829; /* mve_vsubq_fv8hf */

        case E_V2SFmode:
          if (pattern1 (x2, 
E_V2SFmode) != 0
              || !
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 1178; /* *subv2sf3_neon */

        case E_V4SFmode:
          if (pattern1 (x2, 
E_V4SFmode) != 0)
            return -1;
          if (
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return 1179; /* *subv4sf3_neon */
          if (!
#line 1399 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3832; /* mve_vsubq_fv4sf */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 531 "../../gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2DI_ARITH))
            return -1;
          return 1180; /* *subv2di3_neon */

        case E_QQmode:
          if (pattern1 (x2, 
E_QQmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3208; /* subqq3 */

        case E_HQmode:
          if (pattern1 (x2, 
E_HQmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3209; /* subhq3 */

        case E_SQmode:
          if (pattern1 (x2, 
E_SQmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3210; /* subsq3 */

        case E_UQQmode:
          if (pattern1 (x2, 
E_UQQmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3211; /* subuqq3 */

        case E_UHQmode:
          if (pattern1 (x2, 
E_UHQmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3212; /* subuhq3 */

        case E_USQmode:
          if (pattern1 (x2, 
E_USQmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3213; /* subusq3 */

        case E_HAmode:
          if (pattern1 (x2, 
E_HAmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3214; /* subha3 */

        case E_SAmode:
          if (pattern1 (x2, 
E_SAmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3215; /* subsa3 */

        case E_UHAmode:
          if (pattern1 (x2, 
E_UHAmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3216; /* subuha3 */

        case E_USAmode:
          if (pattern1 (x2, 
E_USAmode) != 0
              || !
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT))
            return -1;
          return 3217; /* subusa3 */

        case E_V4QQmode:
          if (pattern1 (x2, 
E_V4QQmode) != 0
              || !
#line 105 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3218; /* *arm_subv4qq3 */

        case E_V2HQmode:
          if (pattern1 (x2, 
E_V2HQmode) != 0
              || !
#line 105 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3219; /* *arm_subv2hq3 */

        case E_V2HAmode:
          if (pattern1 (x2, 
E_V2HAmode) != 0
              || !
#line 105 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ))
            return -1;
          return 3220; /* *arm_subv2ha3 */

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      if (GET_CODE (x4) == MULT)
        {
          res = recog_285 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x4;
      if (!shift_operator (operands[2], E_SImode)
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[4] = x6;
      if (!shift_amount_operand (operands[4], E_SImode)
          || !
#line 9767 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 331; /* *sub_shiftsi */

    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      if (pnum_clobbers == NULL)
        return -1;
      operands[4] = x4;
      if (!minmax_operator (operands[4], E_SImode)
          || pattern432 (x2) != 0
          || !
#line 4301 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1])
   && !(arm_restrict_it && CONST_INT_P (operands[3]))))
        return -1;
      *pnum_clobbers = 1;
      return 126; /* *minmax_arithsi_non_canon */

    case PLUS:
      if (pattern357 (x4, 
SIGN_EXTEND, 
E_DImode, 
MULT) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      x7 = XEXP (x5, 0);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != VEC_SELECT
          || GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XVECEXP (x9, 0, 0);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x5, 1);
      if (pattern536 (x11, 
E_HImode, 
E_DImode, 
SIGN_EXTEND) != 0)
        return -1;
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (GET_CODE (x13) != PARALLEL
          || XVECLEN (x13, 0) != 1)
        return -1;
      x14 = XVECEXP (x13, 0, 0);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != MULT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != SIGN_EXTEND
          || pattern540 (x6, 
E_HImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      switch (pattern650 (x4))
        {
        case 0:
          if (!
#line 657 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 728; /* iwmmxt_wmiabbn */

        case 1:
          if (!
#line 681 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 729; /* iwmmxt_wmiabtn */

        case 2:
          if (!
#line 705 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 730; /* iwmmxt_wmiatbn */

        case 3:
          if (!
#line 729 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 731; /* iwmmxt_wmiattn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != AND
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (!s_register_operand (x5, E_SImode)
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          if (!const_int_operand (x6, E_VOIDmode))
            return -1;
          x7 = XEXP (x4, 1);
          if (!const_int_operand (x7, E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 0);
          switch (GET_CODE (x8))
            {
            case ASHIFT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[1] = x5;
              operands[2] = x6;
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x10 = XEXP (x8, 1);
              operands[4] = x10;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              operands[5] = x7;
              if (!
#line 3539 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[4]) < 32
   && UINTVAL (operands[2]) == ~UINTVAL (operands[5])
   && (exact_log2 (UINTVAL (operands[5])
		   + (HOST_WIDE_INT_1U << UINTVAL (operands[4])))
       >= 0)))
                return -1;
              return 100; /* *bfi */

            case REG:
            case SUBREG:
              operands[3] = x8;
              if (s_register_operand (operands[3], E_SImode))
                {
                  operands[1] = x5;
                  operands[2] = x6;
                  operands[4] = x7;
                  if (
#line 3577 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[2]) == ~UINTVAL (operands[4])
   && exact_log2 (UINTVAL (operands[4]) + 1) >= 0))
                    return 102; /* *bfi_alt2 */
                }
              operands[1] = x8;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x5;
              operands[4] = x6;
              operands[2] = x7;
              if (!
#line 3592 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[2]) == ~UINTVAL (operands[4])
   && exact_log2 (UINTVAL (operands[4]) + 1) >= 0))
                return -1;
              return 103; /* *bfi_alt3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x11 = XEXP (x5, 1);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          operands[4] = x11;
          if (const_int_operand (operands[4], E_VOIDmode)
              && s_register_operand (operands[0], E_SImode))
            {
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              if (s_register_operand (operands[3], E_SImode))
                {
                  x6 = XEXP (x3, 1);
                  operands[5] = x6;
                  if (const_int_operand (operands[5], E_VOIDmode))
                    {
                      x8 = XEXP (x4, 0);
                      operands[1] = x8;
                      if (s_register_operand (operands[1], E_SImode))
                        {
                          x7 = XEXP (x4, 1);
                          operands[2] = x7;
                          if (const_int_operand (operands[2], E_VOIDmode)
                              && 
#line 3559 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[4]) < 32
   && UINTVAL (operands[2]) == ~UINTVAL (operands[5])
   && (exact_log2 (UINTVAL (operands[5])
		   + (HOST_WIDE_INT_1U << UINTVAL (operands[4])))
       >= 0)))
                            return 101; /* *bfi_alt1 */
                        }
                    }
                }
            }
          if (XWINT (x11, 0) != 8LL
              || pattern487 (x2, 
LSHIFTRT) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          x9 = XEXP (x8, 0);
          if (!rtx_equal_p (x9, operands[1])
              || !
#line 12592 "../../gcc/config/arm/arm.md"
(arm_arch6
   && aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode)))
            return -1;
          return 414; /* arm_rev16si2_alt1 */

        case LSHIFTRT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x11 = XEXP (x5, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || pattern487 (x2, 
ASHIFT) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          x9 = XEXP (x8, 0);
          if (!rtx_equal_p (x9, operands[1])
              || !
#line 12613 "../../gcc/config/arm/arm.md"
(arm_arch6
   && aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode)))
            return -1;
          return 415; /* *arm_rev16si2_alt2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern371 (x2) != 0
              || !
#line 3737 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 110; /* *iorsi3_insn */

        case E_DImode:
          if (pattern347 (x2, 
E_DImode) != 0
              || !
#line 61 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 533; /* iwmmxt_iordi3 */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 318 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 546; /* *iorv2si3_iwmmxt */
          if (!s_register_operand (operands[0], E_V2SImode)
              || !s_register_operand (operands[1], E_V2SImode)
              || !neon_logic_op2 (operands[2], E_V2SImode)
              || !
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1247; /* iorv2si3_neon */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 318 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 547; /* *iorv4hi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V4HImode)
              || !s_register_operand (operands[1], E_V4HImode)
              || !neon_logic_op2 (operands[2], E_V4HImode)
              || !
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1245; /* iorv4hi3_neon */

        case E_V8QImode:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 318 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 548; /* *iorv8qi3_iwmmxt */
          if (!s_register_operand (operands[0], E_V8QImode)
              || !s_register_operand (operands[1], E_V8QImode)
              || !neon_logic_op2 (operands[2], E_V8QImode)
              || !
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1243; /* iorv8qi3_neon */

        case E_V16QImode:
          if (pattern372 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1244; /* iorv16qi3_neon */
          if (!
#line 1034 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3682; /* mve_vorrq_sv16qi */

        case E_V8HImode:
          if (pattern372 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1246; /* iorv8hi3_neon */
          if (!
#line 1034 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3683; /* mve_vorrq_sv8hi */

        case E_V4SImode:
          if (pattern372 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1248; /* iorv4si3_neon */
          if (!
#line 1034 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3684; /* mve_vorrq_sv4si */

        case E_V4HFmode:
          if (pattern372 (x2, 
E_V4HFmode) != 0
              || !
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1249; /* iorv4hf3_neon */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x2) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode))
            return -1;
          if (neon_logic_op2 (operands[2], E_V8HFmode)
              && 
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1250; /* iorv8hf3_neon */
          if (!s_register_operand (operands[2], E_V8HFmode)
              || !
#line 1429 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3836; /* mve_vorrq_fv8hf */

        case E_V2SFmode:
          if (pattern372 (x2, 
E_V2SFmode) != 0
              || !
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1251; /* iorv2sf3_neon */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode))
            return -1;
          if (neon_logic_op2 (operands[2], E_V4SFmode)
              && 
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1252; /* iorv4sf3_neon */
          if (!s_register_operand (operands[2], E_V4SFmode)
              || !
#line 1429 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3837; /* mve_vorrq_fv4sf */

        case E_V2DImode:
          if (pattern372 (x2, 
E_V2DImode) != 0
              || !
#line 727 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1253; /* iorv2di3_neon */

        default:
          return -1;
        }

    case MULT:
      if (pattern275 (x2) != 0
          || !
#line 9686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 321; /* *orr_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) == 0
          && 
#line 9700 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return 326; /* *orr_shiftsi */
      if (GET_CODE (x3) != ASHIFT
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x13 = XEXP (x6, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x14 = XEXP (x6, 1);
      if (GET_CODE (x14) != MULT
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x14, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != LSHIFTRT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != ASHIFT
          || GET_MODE (x8) != E_DImode)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != MULT
          || GET_MODE (x10) != E_SImode)
        return -1;
      x16 = XEXP (x10, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MULT
          || GET_MODE (x7) != E_SImode)
        return -1;
      x17 = XEXP (x7, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x18 = XEXP (x14, 0);
      operands[3] = x18;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x19 = XEXP (x10, 0);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      x20 = XEXP (x7, 0);
      if (!rtx_equal_p (x20, operands[3])
          || !
#line 858 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 740; /* iwmmxt_wmerge */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      if (pattern305 (x2) == 0
          && 
#line 9844 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return 335; /* *ior_scc */
      if (pnum_clobbers == NULL
          || pattern306 (x2) != 0
          || !
#line 10494 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_OR_Y)
       != CCmode)))
        return -1;
      *pnum_clobbers = 1;
      return 344; /* *ior_scc_scc */

    case NOT:
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern397 (x2, 
E_SImode) != 0
                  || !
#line 1534 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return -1;
              return 1068; /* *orsi_notsi_si */

            case E_V8QImode:
              if (pattern397 (x2, 
E_V8QImode) != 0
                  || !
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1265; /* ornv8qi3_neon */

            case E_V16QImode:
              if (pattern397 (x2, 
E_V16QImode) != 0)
                return -1;
              if (
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1266; /* ornv16qi3_neon */
              if (!
#line 1006 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3679; /* mve_vornq_sv16qi */

            case E_V4HImode:
              if (pattern397 (x2, 
E_V4HImode) != 0
                  || !
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1267; /* ornv4hi3_neon */

            case E_V8HImode:
              if (pattern397 (x2, 
E_V8HImode) != 0)
                return -1;
              if (
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1268; /* ornv8hi3_neon */
              if (!
#line 1006 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3680; /* mve_vornq_sv8hi */

            case E_V2SImode:
              if (pattern397 (x2, 
E_V2SImode) != 0
                  || !
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1269; /* ornv2si3_neon */

            case E_V4SImode:
              if (pattern397 (x2, 
E_V4SImode) != 0)
                return -1;
              if (
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1270; /* ornv4si3_neon */
              if (!
#line 1006 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3681; /* mve_vornq_sv4si */

            case E_V4HFmode:
              if (pattern397 (x2, 
E_V4HFmode) != 0
                  || !
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1271; /* ornv4hf3_neon */

            case E_V8HFmode:
              if (pattern397 (x2, 
E_V8HFmode) != 0)
                return -1;
              if (
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1272; /* ornv8hf3_neon */
              if (!
#line 1414 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3834; /* mve_vornq_fv8hf */

            case E_V2SFmode:
              if (pattern397 (x2, 
E_V2SFmode) != 0
                  || !
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1273; /* ornv2sf3_neon */

            case E_V4SFmode:
              if (pattern397 (x2, 
E_V4SFmode) != 0)
                return -1;
              if (
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1274; /* ornv4sf3_neon */
              if (!
#line 1414 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3835; /* mve_vornq_fv4sf */

            case E_V2DImode:
              if (pattern397 (x2, 
E_V2DImode) != 0
                  || !
#line 766 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1275; /* ornv2di3_neon */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[4] = x5;
          if (!shift_operator (operands[4], E_SImode)
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x5, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_SImode)
              || !s_register_operand (operands[1], E_SImode)
              || !
#line 1546 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1069; /* *orsi_not_shiftsi_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_QImode))
            return -1;
          if (register_operand (operands[0], E_V8QImode)
              && 
#line 33 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 530; /* tbcstv8qi */
          if (!s_register_operand (operands[0], E_V8QImode)
              || !
#line 3454 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2054; /* neon_vdup_nv8qi */

        case E_V4HImode:
          if (GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_HImode))
            return -1;
          if (register_operand (operands[0], E_V4HImode)
              && 
#line 42 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 531; /* tbcstv4hi */
          if (!s_register_operand (operands[0], E_V4HImode)
              || !
#line 3454 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2055; /* neon_vdup_nv4hi */

        case E_V2SImode:
          if (GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          if (register_operand (operands[0], E_V2SImode)
              && 
#line 51 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 532; /* tbcstv2si */
          if (!s_register_operand (operands[0], E_V2SImode)
              || !
#line 3494 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2062; /* neon_vdup_nv2si */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_QImode))
            return -1;
          if (
#line 3454 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2056; /* neon_vdup_nv16qi */
          if (!
#line 104 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3247; /* mve_vdupq_nv16qi */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_HImode))
            return -1;
          if (
#line 3454 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2057; /* neon_vdup_nv8hi */
          if (!
#line 104 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3248; /* mve_vdupq_nv8hi */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 3462 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2058; /* neon_vdup_nv4hf */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_HFmode))
            return -1;
          if (
#line 3470 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2059; /* neon_vdup_nv8hf */
          if (!
#line 104 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3250; /* mve_vdupq_nv8hf */

        case E_V4BFmode:
          if (!s_register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !s_register_operand (operands[1], E_BFmode)
              || !
#line 3478 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2060; /* neon_vdup_nv4bf */

        case E_V8BFmode:
          if (!s_register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !s_register_operand (operands[1], E_BFmode)
              || !
#line 3486 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2061; /* neon_vdup_nv8bf */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !
#line 3494 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2063; /* neon_vdup_nv2sf */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          if (
#line 3494 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2064; /* neon_vdup_nv4si */
          if (!
#line 104 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3249; /* mve_vdupq_nv4si */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 3494 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 2065; /* neon_vdup_nv4sf */
          if (!
#line 104 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3251; /* mve_vdupq_nv4sf */

        case E_V2DImode:
          if (!s_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !s_register_operand (operands[1], E_DImode)
              || !
#line 3514 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2066; /* neon_vdup_nv2di */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern435 (x3, 
E_V8QImode, 
E_QImode) != 0
              || !
#line 3528 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2067; /* neon_vdup_lanev8qi_internal */

        case E_V16QImode:
          if (pattern436 (x3, 
E_V16QImode, 
E_V8QImode, 
E_QImode) != 0
              || !
#line 3528 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2068; /* neon_vdup_lanev16qi_internal */

        case E_V4HImode:
          if (pattern435 (x3, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 3528 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2069; /* neon_vdup_lanev4hi_internal */

        case E_V8HImode:
          if (pattern436 (x3, 
E_V8HImode, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 3528 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2070; /* neon_vdup_lanev8hi_internal */

        case E_V2SImode:
          if (pattern435 (x3, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 3528 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2071; /* neon_vdup_lanev2si_internal */

        case E_V4SImode:
          if (pattern436 (x3, 
E_V4SImode, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 3528 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2072; /* neon_vdup_lanev4si_internal */

        case E_V2SFmode:
          if (pattern435 (x3, 
E_V2SFmode, 
E_SFmode) != 0
              || !
#line 3528 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2073; /* neon_vdup_lanev2sf_internal */

        case E_V4SFmode:
          if (pattern436 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_SFmode) != 0
              || !
#line 3528 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2074; /* neon_vdup_lanev4sf_internal */

        case E_V8HFmode:
          if (pattern436 (x3, 
E_V8HFmode, 
E_V4HFmode, 
E_HFmode) != 0
              || !
#line 3550 "../../gcc/config/arm/neon.md"
(TARGET_NEON && (TARGET_FP16 || TARGET_BF16_SIMD)))
            return -1;
          return 2075; /* neon_vdup_lanev8hf_internal */

        case E_V4HFmode:
          if (pattern435 (x3, 
E_V4HFmode, 
E_HFmode) != 0
              || !
#line 3550 "../../gcc/config/arm/neon.md"
(TARGET_NEON && (TARGET_FP16 || TARGET_BF16_SIMD)))
            return -1;
          return 2076; /* neon_vdup_lanev4hf_internal */

        case E_V4BFmode:
          if (pattern436 (x3, 
E_V4BFmode, 
E_V4BFmode, 
E_BFmode) != 0
              || !
#line 3550 "../../gcc/config/arm/neon.md"
(TARGET_NEON && (TARGET_FP16 || TARGET_BF16_SIMD)))
            return -1;
          return 2077; /* neon_vdup_lanev4bf_internal */

        case E_V8BFmode:
          if (pattern436 (x3, 
E_V8BFmode, 
E_V4BFmode, 
E_BFmode) != 0
              || !
#line 3550 "../../gcc/config/arm/neon.md"
(TARGET_NEON && (TARGET_FP16 || TARGET_BF16_SIMD)))
            return -1;
          return 2078; /* neon_vdup_lanev8bf_internal */

        default:
          return -1;
        }

    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !neon_struct_operand (operands[1], E_QImode)
              || !
#line 5177 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2634; /* neon_vld1_dupv8qi */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !neon_struct_operand (operands[1], E_HImode)
              || !
#line 5177 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2635; /* neon_vld1_dupv4hi */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !neon_struct_operand (operands[1], E_HFmode)
              || !
#line 5177 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2636; /* neon_vld1_dupv4hf */

        case E_V4BFmode:
          if (!s_register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !neon_struct_operand (operands[1], E_BFmode)
              || !
#line 5177 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2637; /* neon_vld1_dupv4bf */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !neon_struct_operand (operands[1], E_SImode)
              || !
#line 5177 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2638; /* neon_vld1_dupv2si */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !neon_struct_operand (operands[1], E_SFmode)
              || !
#line 5177 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2639; /* neon_vld1_dupv2sf */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !neon_struct_operand (operands[1], E_QImode)
              || !
#line 5194 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2640; /* neon_vld1_dupv16qi */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !neon_struct_operand (operands[1], E_HImode)
              || !
#line 5194 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2641; /* neon_vld1_dupv8hi */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !neon_struct_operand (operands[1], E_HFmode)
              || !
#line 5194 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2642; /* neon_vld1_dupv8hf */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !neon_struct_operand (operands[1], E_SImode)
              || !
#line 5194 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2643; /* neon_vld1_dupv4si */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !neon_struct_operand (operands[1], E_SFmode)
              || !
#line 5194 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2644; /* neon_vld1_dupv4sf */

        case E_V2DImode:
          if (!s_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !neon_struct_operand (operands[1], E_DImode)
              || !
#line 5204 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2645; /* neon_vld1_dupv2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (s_register_operand (operands[0], E_SImode)
              && s_register_operand (operands[1], E_SImode)
              && 
#line 5179 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 168; /* *arm_negsi2 */
          if (register_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_SImode)
              && 
#line 324 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 956; /* *thumb1_negsi2 */
          if (pnum_clobbers == NULL
              || !low_register_operand (operands[0], E_SImode)
              || !low_register_operand (operands[1], E_SImode)
              || !
#line 1523 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1067; /* *thumb2_negsi2_short */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !
#line 890 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 784; /* *negsf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !
#line 901 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 785; /* *negdf2_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x3) != E_HFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 949 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 787; /* neghf2 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 315 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          *pnum_clobbers = 1;
          return 955; /* *thumb1_negdi2 */

        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 811 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1317; /* neon_negv8qi2 */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode))
            return -1;
          if (
#line 811 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1318; /* neon_negv16qi2 */
          if (!
#line 280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3293; /* mve_vnegq_sv16qi */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_V4HImode)
              || !
#line 811 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1319; /* neon_negv4hi2 */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_V8HImode))
            return -1;
          if (
#line 811 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1320; /* neon_negv8hi2 */
          if (!
#line 280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3295; /* mve_vnegq_sv8hi */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_V2SImode)
              || !
#line 811 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1321; /* neon_negv2si2 */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_V4SImode))
            return -1;
          if (
#line 811 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1322; /* neon_negv4si2 */
          if (!
#line 280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3297; /* mve_vnegq_sv4si */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_V2SFmode)
              || !
#line 811 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1323; /* neon_negv2sf2 */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode))
            return -1;
          if (
#line 811 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1324; /* neon_negv4sf2 */
          if (!
#line 189 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3274; /* mve_vnegq_fv4sf */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode))
            return -1;
          if (
#line 822 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return 1326; /* neon_negv8hf2 */
          if (!
#line 189 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3272; /* mve_vnegq_fv8hf */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_V4HFmode)
              || !
#line 822 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1328; /* neon_negv4hf2 */

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL
          || pattern244 (x3, 
E_SImode) != 0)
        return -1;
      if (
#line 5319 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        {
          *pnum_clobbers = 1;
          return 172; /* *arm_neg_abssi2 */
        }
      if (
#line 349 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        {
          *pnum_clobbers = 1;
          return 958; /* *thumb1_neg_abssi2 */
        }
      if (!
#line 170 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1012; /* *thumb2_neg_abssi2 */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_296 (x1, insn, pnum_clobbers);

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (pattern281 (x3, 
E_HFmode) != 0
              || !
#line 1143 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 808; /* *negmulhf3_vfp */

        case E_SFmode:
          if (pattern281 (x3, 
E_SFmode) != 0
              || !
#line 1163 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 810; /* *negmulsf3_vfp */

        case E_DFmode:
          if (pattern281 (x3, 
E_DFmode) != 0
              || !
#line 1184 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 812; /* *negmuldf3_vfp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[3] = x4;
      if (!shift_operator (operands[3], E_SImode)
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!shift_amount_operand (operands[2], E_SImode)
          || !
#line 4797 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 154; /* *not_shiftsi */

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (s_register_operand (operands[0], E_SImode)
              && s_register_operand (operands[1], E_SImode)
              && 
#line 5402 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 173; /* *arm_one_cmplsi2 */
          if (register_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_SImode)
              && 
#line 363 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 959; /* *thumb1_one_cmplsi2 */
          if (pnum_clobbers == NULL
              || !low_register_operand (operands[0], E_SImode)
              || !low_register_operand (operands[1], E_SImode)
              || !
#line 1512 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1066; /* *thumb2_one_cmplsi2_short */

        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1298; /* one_cmplv8qi2_neon */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode))
            return -1;
          if (
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1299; /* one_cmplv16qi2_neon */
          if (!
#line 294 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3298; /* mve_vmvnq_uv16qi */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_V4HImode)
              || !
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1300; /* one_cmplv4hi2_neon */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_V8HImode))
            return -1;
          if (
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1301; /* one_cmplv8hi2_neon */
          if (!
#line 294 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3299; /* mve_vmvnq_uv8hi */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_V2SImode)
              || !
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1302; /* one_cmplv2si2_neon */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_V4SImode))
            return -1;
          if (
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1303; /* one_cmplv4si2_neon */
          if (!
#line 294 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3300; /* mve_vmvnq_uv4si */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_V4HFmode)
              || !
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1304; /* one_cmplv4hf2_neon */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode)
              || !
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1305; /* one_cmplv8hf2_neon */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_V2SFmode)
              || !
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1306; /* one_cmplv2sf2_neon */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode)
              || !
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1307; /* one_cmplv4sf2_neon */

        case E_V2DImode:
          if (!s_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !s_register_operand (operands[1], E_V2DImode)
              || !
#line 792 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1308; /* one_cmplv2di2_neon */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x4;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      if (s_register_operand (operands[0], E_SImode))
        {
          if (arm_comparison_operator (operands[1], E_SImode)
              && 
#line 8138 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 282; /* *mov_notscc */
          if (arm_comparison_operator_mode (operands[1], E_SImode)
              && 
#line 396 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
            return 1021; /* *thumb2_mov_notscc */
        }
      if (!low_register_operand (operands[0], E_SImode)
          || !arm_comparison_operator_mode (operands[1], E_SImode)
          || !
#line 416 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
        return -1;
      return 1022; /* *thumb2_mov_notscc_strict_it */

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL
          || pattern267 (x3, 
1) != 0)
        return -1;
      x7 = XEXP (x4, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11857 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 383; /* *not_signextract_onebit */

    default:
      return -1;
    }
}

 int
recog_320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 451 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 567; /* ussubv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1456 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1466; /* *us_subv8qi_neon */

    case 1:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 461 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 568; /* ussubv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1456 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1467; /* *us_subv4hi_neon */

    case 2:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 471 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 569; /* ussubv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1456 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1468; /* *us_subv2si_neon */

    case 3:
      if (!
#line 1456 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1469; /* *us_subv2sf_neon */

    case 4:
      if (!
#line 115 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3221; /* ussubv4uqq3 */

    case 5:
      if (!
#line 115 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3222; /* ussubv2uhq3 */

    case 6:
      if (!
#line 115 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3223; /* ussubuqq3 */

    case 7:
      if (!
#line 115 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3224; /* ussubuhq3 */

    case 8:
      if (!
#line 115 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3225; /* ussubv2uha3 */

    case 9:
      if (!
#line 115 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3226; /* ussubuha3 */

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (x4))
        {
        case E_SFmode:
          if (!s_register_operand (operands[1], E_SFmode)
              || !
#line 1531 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 845; /* fixuns_truncsfsi2 */

        case E_DFmode:
          if (!s_register_operand (operands[1], E_DFmode)
              || !
#line 1540 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 846; /* fixuns_truncdfsi2 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern252 (x3))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 906; /* lceilusfsi2 */

        case 1:
          if (!(
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 912; /* lceiludfsi2 */

        case 2:
          if (!
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 907; /* lfloorusfsi2 */

        case 3:
          if (!(
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 913; /* lfloorudfsi2 */

        case 4:
          if (!
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 908; /* lroundusfsi2 */

        case 5:
          if (!(
#line 2053 "../../gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 914; /* lroundudfsi2 */

        case 6:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1234; /* neon_vcvtpuv2sfv2si */

        case 7:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1240; /* neon_vcvtpuv4sfv4si */

        case 8:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1235; /* neon_vcvtmuv2sfv2si */

        case 9:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1241; /* neon_vcvtmuv4sfv4si */

        case 10:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1236; /* neon_vcvtauv2sfv2si */

        case 11:
          if (!
#line 717 "../../gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1242; /* neon_vcvtauv4sfv4si */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 3709 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2106; /* fixuns_truncv2sfv2si2 */

        case 1:
          if (!
#line 3709 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2107; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x5) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          operands[3] = x7;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2292 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2)))
            return -1;
          return 6418; /* *p *mls */

        case E_SFmode:
          if (pattern555 (x5, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1279 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6931; /* *p *mulsf3negsfaddsf_vfp */

        case E_DFmode:
          if (pattern555 (x5, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1290 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6932; /* *p *fmuldf3negdfadddf_vfp */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern540 (x6, 
E_SImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (pattern627 (x6))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 794 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6874; /* *p iwmmxt_wmiawbbn */

        case 1:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 807 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6875; /* *p iwmmxt_wmiawbtn */

        case 2:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 820 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6876; /* *p iwmmxt_wmiawtbn */

        case 3:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 833 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6877; /* *p iwmmxt_wmiawttn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case MINUS:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x8 = XEXP (x1, 0);
              operands[4] = x8;
              x9 = XEXP (x8, 0);
              operands[5] = x9;
              if (!reg_or_int_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[3] = x10;
              if (!arm_borrow_operation (operands[3], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1697 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6407; /* *p subsi3_carryin */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[2] = x7;
              if (!shift_operator (operands[2], E_SImode))
                return -1;
              x8 = XEXP (x1, 0);
              operands[6] = x8;
              x9 = XEXP (x8, 0);
              operands[7] = x9;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x7, 0);
              operands[3] = x11;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[4] = x12;
              if (!shift_amount_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1831 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6411; /* *p *subsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x7;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              if (!shift_operator (x10, E_SImode))
                return -1;
              operands[2] = x10;
              x8 = XEXP (x1, 0);
              operands[6] = x8;
              x9 = XEXP (x8, 0);
              operands[7] = x9;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x10, 0);
              operands[3] = x13;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x14 = XEXP (x10, 1);
              operands[4] = x14;
              if (!shift_amount_operand (operands[4], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1848 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6412; /* *p *subsi3_carryin_shift_alt */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x6;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x1, 0);
          operands[6] = x8;
          x9 = XEXP (x8, 0);
          operands[7] = x9;
          x15 = XEXP (x6, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x16 = XEXP (x6, 1);
          operands[4] = x16;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1866 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
                return -1;
              return 6413; /* *p *rsbsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x7;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[1] = x10;
              if (!s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1881 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
                return -1;
              return 6414; /* *p *rsbsi3_carryin_shift_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[1] = x5;
      if (!arm_carry_operation (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[3] = x8;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1714 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
        return -1;
      return 6408; /* *p rsbsi_carryin_reg */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x10;
          x8 = XEXP (x1, 0);
          operands[3] = x8;
          x9 = XEXP (x8, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !reg_or_int_operand (operands[1], E_SImode)
                  || !reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2020 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6415; /* *p *arm_subsi3_insn */

            case E_V2SImode:
              if (pattern311 (x4, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6699; /* *p *subv2si3_iwmmxt */

            case E_V4HImode:
              if (pattern311 (x4, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6700; /* *p *subv4hi3_iwmmxt */

            case E_V8QImode:
              if (pattern311 (x4, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6701; /* *p *subv8qi3_iwmmxt */

            case E_SFmode:
              if (pattern310 (x4, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1038 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                return -1;
              return 6917; /* *p *subsf3_vfp */

            case E_DFmode:
              if (pattern310 (x4, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1048 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                return -1;
              return 6918; /* *p *subdf3_vfp */

            case E_QQmode:
              if (pattern310 (x4, 
E_QQmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7030; /* *p subqq3 */

            case E_HQmode:
              if (pattern310 (x4, 
E_HQmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7031; /* *p subhq3 */

            case E_SQmode:
              if (pattern310 (x4, 
E_SQmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7032; /* *p subsq3 */

            case E_UQQmode:
              if (pattern310 (x4, 
E_UQQmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7033; /* *p subuqq3 */

            case E_UHQmode:
              if (pattern310 (x4, 
E_UHQmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7034; /* *p subuhq3 */

            case E_USQmode:
              if (pattern310 (x4, 
E_USQmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7035; /* *p subusq3 */

            case E_HAmode:
              if (pattern310 (x4, 
E_HAmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7036; /* *p subha3 */

            case E_SAmode:
              if (pattern310 (x4, 
E_SAmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7037; /* *p subsa3 */

            case E_UHAmode:
              if (pattern310 (x4, 
E_UHAmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7038; /* *p subuha3 */

            case E_USAmode:
              if (pattern310 (x4, 
E_USAmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7039; /* *p subusa3 */

            case E_V4QQmode:
              if (pattern310 (x4, 
E_V4QQmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7040; /* *p *arm_subv4qq3 */

            case E_V2HQmode:
              if (pattern310 (x4, 
E_V2HQmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7041; /* *p *arm_subv2hq3 */

            case E_V2HAmode:
              if (pattern310 (x4, 
E_V2HAmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7042; /* *p *arm_subv2ha3 */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (GET_CODE (x10) == MULT)
            {
              res = recog_334 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x10;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x1, 0);
          operands[5] = x8;
          x9 = XEXP (x8, 0);
          operands[6] = x9;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x14 = XEXP (x10, 1);
          operands[4] = x14;
          if (!shift_amount_operand (operands[4], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9767 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6593; /* *p *sub_shiftsi */

        case PLUS:
          if (pattern438 (x10) != 0)
            return -1;
          x13 = XEXP (x10, 0);
          x17 = XEXP (x13, 0);
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != VEC_SELECT
              || GET_MODE (x18) != E_HImode)
            return -1;
          x19 = XEXP (x18, 1);
          if (GET_CODE (x19) != PARALLEL
              || XVECLEN (x19, 0) != 1)
            return -1;
          x20 = XVECEXP (x19, 0, 0);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XEXP (x13, 1);
          if (pattern600 (x21, 
E_HImode, 
E_DImode, 
SIGN_EXTEND) != 0)
            return -1;
          x22 = XEXP (x21, 0);
          x23 = XEXP (x22, 1);
          if (GET_CODE (x23) != PARALLEL
              || XVECLEN (x23, 0) != 1)
            return -1;
          x24 = XVECEXP (x23, 0, 0);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          x14 = XEXP (x10, 1);
          if (pattern583 (x14) != 0)
            return -1;
          x25 = XEXP (x14, 0);
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != VEC_SELECT
              || GET_MODE (x26) != E_HImode)
            return -1;
          x27 = XEXP (x26, 1);
          if (GET_CODE (x27) != PARALLEL
              || XVECLEN (x27, 0) != 1)
            return -1;
          x28 = XVECEXP (x27, 0, 0);
          if (GET_CODE (x28) != CONST_INT)
            return -1;
          x29 = XEXP (x14, 1);
          if (GET_CODE (x29) != SIGN_EXTEND
              || GET_MODE (x29) != E_DImode)
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != VEC_SELECT
              || GET_MODE (x30) != E_HImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (GET_CODE (x31) != PARALLEL
              || XVECLEN (x31, 0) != 1)
            return -1;
          x32 = XVECEXP (x31, 0, 0);
          if (GET_CODE (x32) != CONST_INT)
            return -1;
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          switch (pattern656 (x10))
            {
            case 0:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 657 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6866; /* *p iwmmxt_wmiabbn */

            case 1:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 681 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6867; /* *p iwmmxt_wmiabtn */

            case 2:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 705 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6868; /* *p iwmmxt_wmiatbn */

            case 3:
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 729 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6869; /* *p iwmmxt_wmiattn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          switch (GET_CODE (operands[3]))
            {
            case CONST_INT:
              if (!power_of_two_operand (operands[3], E_SImode)
                  || !s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || !s_register_operand (operands[2], E_SImode)
                  || !s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6584; /* *p *rsb_multsi */

            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern569 (x4, 
E_SFmode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1245 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                    return -1;
                  return 6929; /* *p *mulsf3subsf_vfp */

                case E_DFmode:
                  if (pattern569 (x4, 
E_DFmode) != 0
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1256 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                    return -1;
                  return 6930; /* *p *muldf3subdf_vfp */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern406 (x5, 
2, 
0) != 0)
            return -1;
          x7 = XEXP (x5, 1);
          x12 = XEXP (x7, 1);
          x33 = XVECEXP (x12, 0, 0);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x34 = XVECEXP (x12, 0, 1);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x10 = XEXP (x4, 1);
          if (pattern599 (x10, 
3, 
1) != 0)
            return -1;
          x14 = XEXP (x10, 1);
          if (GET_CODE (x14) != VEC_SELECT
              || GET_MODE (x14) != E_V2SImode)
            return -1;
          x29 = XEXP (x14, 1);
          if (GET_CODE (x29) != PARALLEL
              || XVECLEN (x29, 0) != 2)
            return -1;
          x35 = XVECEXP (x29, 0, 0);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x36 = XVECEXP (x29, 0, 1);
          if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          switch (pattern636 (x1))
            {
            case 0:
              if (pattern652 (x4, 
SIGN_EXTEND) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 232 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6839; /* *p iwmmxt_wmaddsn */

            case 1:
              if (pattern652 (x4, 
ZERO_EXTEND) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 251 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6840; /* *p iwmmxt_wmaddun */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern556 (x4, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1316 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                return -1;
              return 6933; /* *p *mulsf3negsfsubsf_vfp */

            case E_DFmode:
              if (pattern556 (x4, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1328 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                return -1;
              return 6934; /* *p *muldf3negdfsubdf_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x5;
      if (pattern407 (x1) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
        return -1;
      return 6589; /* *p *rsb_shiftsi */

    default:
      return -1;
    }
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_326 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_327 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x4 = XEXP (x1, 0);
      operands[1] = x4;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      if (s_register_operand (operands[0], E_SImode)
          && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9629 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
        return 6581; /* *p *arm_indirect_jump */
      if (memory_operand (operands[0], E_SImode)
          && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9638 "../../gcc/config/arm/arm.md"
(TARGET_ARM)))
        return 6582; /* *p *load_indirect_jump */
      break;

    default:
      break;
    }
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      res = recog_328 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_329 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x1, 0);
          operands[1] = x4;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 8591 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return 6577; /* *p *arm_jump */
        }
      break;

    case CONST_VECTOR:
      res = recog_330 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      res = recog_331 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x6;
  if (general_operand (operands[1], E_SImode))
    {
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      operands[0] = x3;
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 238 "../../gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode)))))
            return 6903; /* *p *arm_movsi_vfp */
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 283 "../../gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode)))))
            return 6904; /* *p *thumb2_movsi_vfp */
        }
    }
  operands[0] = x3;
  if (low_register_operand (operands[0], E_SImode)
      && GET_CODE (x6) == MEM
      && pattern357 (x6, 
REG, 
E_SImode, 
POST_INC) == 0)
    {
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) == 13
          && GET_MODE (x8) == E_SImode)
        {
          x4 = XEXP (x1, 0);
          operands[1] = x4;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 223 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && (reload_in_progress || reload_completed))))
            return 6980; /* *p *thumb2_pop_single */
        }
    }
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  operands[1] = x6;
  if (!general_operand (operands[1], E_SImode)
      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 238 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode)))))
    return -1;
  return 6981; /* *p *thumb2_movsi_insn */
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XVECEXP (x2, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!memory_operand (operands[3], E_SImode)
      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 164 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, true))))
    return -1;
  return 6620; /* *p *arm_ldrd */
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  switch (pattern443 (x2))
    {
    case 0:
      if (pattern525 (x2) != 0)
        return -1;
      x6 = XEXP (x1, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[6] = x7;
      if (pattern606 (operands[0]) != 0)
        return -1;
      x8 = XEXP (x3, 1);
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[4] = x9;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 1);
          if (XWINT (x12, 0) != 4LL)
            return -1;
          x13 = XEXP (x5, 1);
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[4])
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 477 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
            return -1;
          return 6638; /* *p *ldm3_ */

        case PLUS:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x18 = XEXP (x9, 1);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XEXP (x9, 0);
          operands[4] = x19;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          x11 = XEXP (x10, 0);
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != 8LL)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (pattern638 (x14, 
12) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 582 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6642; /* *p *ldm3_ib */

            case -8LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -4LL)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[4])
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 643 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6646; /* *p *ldm3_da */

            case -12LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -8LL)
                return -1;
              x13 = XEXP (x5, 1);
              x14 = XEXP (x13, 0);
              if (pattern638 (x14, 
-4) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 704 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6650; /* *p *ldm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern564 (x2) != 0)
        return -1;
      x6 = XEXP (x1, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[6] = x7;
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[3] = x13;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x20 = XEXP (x3, 0);
      x21 = XEXP (x20, 0);
      switch (GET_CODE (x21))
        {
        case REG:
        case SUBREG:
          operands[4] = x21;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x22 = XEXP (x4, 0);
          x23 = XEXP (x22, 0);
          x24 = XEXP (x23, 1);
          if (XWINT (x24, 0) != 4LL)
            return -1;
          x25 = XEXP (x5, 0);
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != PLUS
              || GET_MODE (x26) != E_SImode)
            return -1;
          x27 = XEXP (x26, 1);
          if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x28 = XEXP (x23, 0);
          if (!rtx_equal_p (x28, operands[4]))
            return -1;
          x29 = XEXP (x26, 0);
          if (!rtx_equal_p (x29, operands[4])
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 537 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
            return -1;
          return 6640; /* *p *stm3_ */

        case PLUS:
          if (GET_MODE (x21) != E_SImode)
            return -1;
          x30 = XEXP (x21, 1);
          if (GET_CODE (x30) != CONST_INT)
            return -1;
          x31 = XEXP (x21, 0);
          operands[4] = x31;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x22 = XEXP (x4, 0);
          x23 = XEXP (x22, 0);
          x28 = XEXP (x23, 0);
          if (!rtx_equal_p (x28, operands[4]))
            return -1;
          switch (XWINT (x30, 0))
            {
            case 4LL:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != 8LL)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (pattern640 (x26, 
12) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 613 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6644; /* *p *stm3_ib */

            case -8LL:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != -4LL)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (!rtx_equal_p (x26, operands[4])
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 673 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6648; /* *p *stm3_da */

            case -12LL:
              x24 = XEXP (x23, 1);
              if (XWINT (x24, 0) != -8LL)
                return -1;
              x25 = XEXP (x5, 0);
              x26 = XEXP (x25, 0);
              if (pattern640 (x26, 
-4) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 735 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                return -1;
              return 6652; /* *p *stm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      x20 = XEXP (x3, 0);
      operands[3] = x20;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x32 = XEXP (x8, 1);
      switch (XWINT (x32, 0))
        {
        case 8LL:
          switch (pattern597 (x4))
            {
            case 0:
              x13 = XEXP (x5, 1);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x22 = XEXP (x4, 0);
              operands[1] = x22;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x25 = XEXP (x5, 0);
              operands[2] = x25;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              if (!rtx_equal_p (x17, operands[3]))
                return -1;
              x10 = XEXP (x4, 1);
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x11, operands[3])
                      || XWINT (x15, 0) != 4LL
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 880 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6655; /* *p *ldm2_ia_update */

                case PLUS:
                  if (GET_MODE (x11) != E_SImode)
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x15, 0) != 8LL)
                    return -1;
                  x16 = XEXP (x11, 0);
                  if (!rtx_equal_p (x16, operands[3])
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 957 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6659; /* *p *ldm2_ib_update */

                default:
                  return -1;
                }

            case 1:
              x25 = XEXP (x5, 0);
              if (GET_CODE (x25) != MEM
                  || GET_MODE (x25) != E_SImode)
                return -1;
              x26 = XEXP (x25, 0);
              if (GET_CODE (x26) != PLUS
                  || GET_MODE (x26) != E_SImode)
                return -1;
              x27 = XEXP (x26, 1);
              if (GET_CODE (x27) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x5, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x29 = XEXP (x26, 0);
              if (!rtx_equal_p (x29, operands[3]))
                return -1;
              x22 = XEXP (x4, 0);
              x23 = XEXP (x22, 0);
              switch (GET_CODE (x23))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x23, operands[3])
                      || XWINT (x27, 0) != 4LL
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 917 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6657; /* *p *stm2_ia_update */

                case PLUS:
                  if (GET_MODE (x23) != E_SImode)
                    return -1;
                  x24 = XEXP (x23, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x27, 0) != 8LL)
                    return -1;
                  x28 = XEXP (x23, 0);
                  if (!rtx_equal_p (x28, operands[3])
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 981 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6661; /* *p *stm2_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -8LL:
          x10 = XEXP (x4, 1);
          switch (GET_CODE (x10))
            {
            case MEM:
              if (pattern525 (x2) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x22 = XEXP (x4, 0);
              operands[1] = x22;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x25 = XEXP (x5, 0);
              operands[2] = x25;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x10, 0);
              x16 = XEXP (x11, 0);
              if (!rtx_equal_p (x16, operands[3]))
                return -1;
              x12 = XEXP (x11, 1);
              switch (XWINT (x12, 0))
                {
                case -4LL:
                  x13 = XEXP (x5, 1);
                  x14 = XEXP (x13, 0);
                  if (!rtx_equal_p (x14, operands[3])
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1007 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6663; /* *p *ldm2_da_update */

                case -8LL:
                  x13 = XEXP (x5, 1);
                  x14 = XEXP (x13, 0);
                  if (GET_CODE (x14) != PLUS
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x15 = XEXP (x14, 1);
                  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[3])
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1059 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6667; /* *p *ldm2_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x10;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern564 (x2) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x5, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x22 = XEXP (x4, 0);
              x23 = XEXP (x22, 0);
              x28 = XEXP (x23, 0);
              if (!rtx_equal_p (x28, operands[3]))
                return -1;
              x24 = XEXP (x23, 1);
              switch (XWINT (x24, 0))
                {
                case -4LL:
                  x25 = XEXP (x5, 0);
                  x26 = XEXP (x25, 0);
                  if (!rtx_equal_p (x26, operands[3])
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1031 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6665; /* *p *stm2_da_update */

                case -8LL:
                  x25 = XEXP (x5, 0);
                  x26 = XEXP (x25, 0);
                  if (GET_CODE (x26) != PLUS
                      || GET_MODE (x26) != E_SImode)
                    return -1;
                  x27 = XEXP (x26, 1);
                  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x29 = XEXP (x26, 0);
                  if (!rtx_equal_p (x29, operands[3])
                      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1083 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3)))
                    return -1;
                  return 6669; /* *p *stm2_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (s_register_operand (operands[1], E_SImode)
          && s_register_operand (operands[0], E_SImode))
        {
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (reg_or_int_operand (operands[2], E_SImode)
              && 
#line 962 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_op (INTVAL (operands[2]), PLUS)
   && (reload_completed || !arm_eliminable_register (operands[1]))))
            return gen_split_1 (insn, operands);
        }
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !(
#line 66 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1) && 
#line 87 "../../gcc/config/arm/thumb1.md"
( reload_completed && CONST_INT_P (operands[2])
   && ((operands[1] != stack_pointer_rtx
        && (INTVAL (operands[2]) > 255 || INTVAL (operands[2]) < -255))
       || (operands[1] == stack_pointer_rtx
 	   && INTVAL (operands[2]) > 1020)))))
        return NULL;
      return gen_split_113 (insn, operands);

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_int_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!reg_or_int_operand (operands[2], E_SImode)
          || !(
#line 2020 "../../gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 2031 "../../gcc/config/arm/arm.md"
( (CONST_INT_P (operands[1])
       && !const_ok_for_arm (INTVAL (operands[1]))))))
        return NULL;
      return gen_split_3 (insn, operands);

    case AND:
    case IOR:
    case XOR:
      operands[6] = x2;
      if (logical_binary_operator (operands[6], E_DImode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (s_register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (s_register_operand (operands[1], E_DImode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (s_register_operand (operands[2], E_DImode)
                      && 
#line 2902 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed
   && ! IS_IWMMXT_REGNUM (REGNO (operands[0]))))
                    return gen_split_4 (insn, operands);
                }
            }
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return NULL;
      switch (GET_CODE (x2))
        {
        case AND:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3031 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
	|| const_ok_for_arm (~INTVAL (operands[2]))
	|| (arm_arch_thumb2
	    && satisfies_constraint_Dj (operands[2])
	    && (rtx_equal_p (operands[0], operands[1])
		|| !reload_completed)))))
                return NULL;
              return gen_split_6 (insn, operands);

            case IOR:
              if (GET_MODE (x4) != E_SImode)
                return NULL;
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) != NOT
                  || GET_MODE (x5) != E_SImode)
                return NULL;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return NULL;
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !(
#line 3910 "../../gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 3912 "../../gcc/config/arm/arm.md"
( reload_completed)))
                return NULL;
              return gen_split_17 (insn, operands);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              operands[1] = x4;
              if (!arm_comparison_operator (operands[1], E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (!cc_register (operands[2], E_VOIDmode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (!s_register_operand (operands[3], E_SImode))
                return NULL;
              if ((
#line 9815 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 9817 "../../gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_78 (insn, operands);
              if (!(
#line 618 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 620 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_146 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3744 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
        || (TARGET_THUMB2 && const_ok_for_arm (~INTVAL (operands[2]))))))
                return NULL;
              return gen_split_14 (insn, operands);

            case AND:
              if (pattern361 (x2) != 0
                  || !
#line 5817 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[3])
       == (GET_MODE_MASK (GET_MODE (operands[5]))
           & (GET_MODE_MASK (GET_MODE (operands[5]))
	      << (INTVAL (operands[2])))))))
                return NULL;
              return gen_split_35 (insn, operands);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              if (!arm_comparison_operator (x4, E_SImode))
                return NULL;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x4, 0);
              if (!cc_register (x6, E_VOIDmode))
                return NULL;
              operands[2] = x6;
              operands[1] = x4;
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (s_register_operand (operands[3], E_SImode))
                {
                  if ((
#line 9844 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 9848 "../../gcc/config/arm/arm.md"
( reload_completed
   && REGNO (operands [0]) != REGNO (operands[3]))))
                    return gen_split_79 (insn, operands);
                  if ((
#line 646 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it) && 
#line 651 "../../gcc/config/arm/thumb2.md"
( reload_completed
    && REGNO (operands [0]) != REGNO (operands[3]))))
                    return gen_split_147 (insn, operands);
                }
              operands[3] = x6;
              operands[2] = x4;
              operands[1] = x5;
              if (!s_register_operand (operands[1], E_SImode)
                  || !(
#line 677 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 679 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_148 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !
#line 3849 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_arm (INTVAL (operands[2]))))
                return NULL;
              return gen_split_15 (insn, operands);

            case AND:
              if (pattern361 (x2) != 0
                  || !
#line 5817 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[3])
       == (GET_MODE_MASK (GET_MODE (operands[5]))
           & (GET_MODE_MASK (GET_MODE (operands[5]))
	      << (INTVAL (operands[2])))))))
                return NULL;
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!s_register_operand (operands[1], E_DImode)
              || !s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 2922 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_5 (insn, operands);

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x2) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return NULL;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (arm_comparison_operator (operands[1], E_SImode)
                  && 
#line 8140 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return gen_split_73 (insn, operands);
              if (arm_comparison_operator_mode (operands[1], E_SImode)
                  && (
#line 396 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it) && 
#line 398 "../../gcc/config/arm/thumb2.md"
( true)))
                return gen_split_143 (insn, operands);
            }
          if (!low_register_operand (operands[0], E_SImode)
              || !arm_comparison_operator_mode (operands[1], E_SImode)
              || !(
#line 416 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 418 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_VOIDmode)
              || !
#line 5622 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_29 (insn, operands);

        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!s_register_operand (operands[1], E_HImode)
                  || !
#line 5678 "../../gcc/config/arm/arm.md"
(!TARGET_THUMB2 && !arm_arch6))
                return NULL;
              return gen_split_31 (insn, operands);

            case E_QImode:
              if (!s_register_operand (operands[1], E_QImode)
                  || !
#line 5742 "../../gcc/config/arm/arm.md"
(!arm_arch6))
                return NULL;
              return gen_split_32 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_VOIDmode)
              || !
#line 5640 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_30 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !
#line 5917 "../../gcc/config/arm/arm.md"
(!arm_arch6))
                return NULL;
              return gen_split_38 (insn, operands);

            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && 
#line 6011 "../../gcc/config/arm/arm.md"
(!arm_arch6))
                return gen_split_39 (insn, operands);
              if (!memory_operand (operands[1], E_QImode)
                  || !
#line 512 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed))
                return NULL;
              return gen_split_118 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_2 (x1, insn);

    case UNSPEC:
      if (XVECLEN (x2, 0) != 2)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x9 = XVECEXP (x2, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x2, 0, 1);
      operands[2] = x10;
      switch (XINT (x2, 1))
        {
        case 27:
          if (GET_MODE (x2) != E_SImode
              || !s_register_operand (operands[0], E_SImode)
              || !(
#line 6690 "../../gcc/config/arm/arm.md"
(flag_pic) && 
#line 6692 "../../gcc/config/arm/arm.md"
( reload_completed)))
            return NULL;
          return gen_split_67 (insn, operands);

        case 343:
          if (GET_MODE (x2) != E_V16QImode
              || !s_register_operand (operands[0], E_V16QImode))
            return NULL;
          switch (pattern415 ())
            {
            case 0:
              if (!(
#line 4748 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4750 "../../gcc/config/arm/neon.md"
( reload_completed)))
                return NULL;
              return gen_split_173 (insn, operands);

            case 1:
              if (!(
#line 4779 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4781 "../../gcc/config/arm/neon.md"
( reload_completed)))
                return NULL;
              return gen_split_174 (insn, operands);

            default:
              return NULL;
            }

        case 171:
          if (GET_MODE (x2) != E_OImode
              || !s_register_operand (operands[0], E_OImode)
              || !s_register_operand (operands[1], E_V16QImode)
              || !s_register_operand (operands[2], E_V16QImode)
              || !(
#line 4814 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 4816 "../../gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_175 (insn, operands);

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      if (arm_comparison_operator_mode (operands[1], E_SImode))
        {
          x5 = XEXP (x2, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[2] = x4;
                  if (cc_register (operands[2], E_VOIDmode)
                      && 
#line 8094 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                    return gen_split_71 (insn, operands);
                }
            }
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (s_register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              switch (GET_CODE (x2))
                {
                case LTU:
                  if (thumb1_cmp_operand (operands[2], E_SImode)
                      && 
#line 1791 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return gen_split_130 (insn, operands);
                  break;

                case LEU:
                  if (s_register_operand (operands[2], E_SImode)
                      && 
#line 1819 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
  && !reg_overlap_mentioned_p (operands[0], operands[1])
  && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    return gen_split_131 (insn, operands);
                  break;

                case GEU:
                  if (thumb1_cmp_operand (operands[2], E_SImode)
                      && 
#line 1832 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
  && !reg_overlap_mentioned_p (operands[0], operands[1])
  && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    return gen_split_132 (insn, operands);
                  break;

                default:
                  break;
                }
            }
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[1] = x2;
      if (!arm_comparison_operator_mode (operands[1], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!cc_register (operands[2], E_VOIDmode)
          || !
#line 328 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return NULL;
      return gen_split_140 (insn, operands);

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator_mode (operands[1], E_SImode))
            return NULL;
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x2) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return NULL;
          if (s_register_operand (operands[0], E_SImode))
            {
              if ((
#line 8119 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !arm_borrow_operation (operands[1], SImode)) && 
#line 8121 "../../gcc/config/arm/arm.md"
( true)))
                return gen_split_72 (insn, operands);
              if ((
#line 344 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && !arm_restrict_it
   && !arm_borrow_operation (operands[1], SImode)) && 
#line 348 "../../gcc/config/arm/thumb2.md"
( true)))
                return gen_split_141 (insn, operands);
            }
          if (!low_register_operand (operands[0], E_SImode)
              || !(
#line 365 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && arm_restrict_it
   && !arm_borrow_operation (operands[1], SImode)) && 
#line 369 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case REG:
        case SUBREG:
          if (!s_register_operand (operands[1], E_DFmode)
              || !s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 906 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE && reload_completed
   && arm_general_register_operand (operands[0], DFmode)))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (!arm_comparison_operator (x4, E_VOIDmode))
        return NULL;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x4, 0);
      if (!cc_register (x6, E_VOIDmode))
        return NULL;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x5;
          x11 = XEXP (x2, 2);
          switch (GET_CODE (x11))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x11;
              if (!arm_not_operand (operands[2], E_SImode))
                return NULL;
              operands[3] = x4;
              operands[4] = x6;
              if (!arm_not_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 8506 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 8520 "../../gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_74 (insn, operands);
              if (!(
#line 442 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 462 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_145 (insn, operands);

            case NEG:
              if (GET_MODE (x11) != E_SImode)
                return NULL;
              operands[4] = x4;
              operands[3] = x6;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x12 = XEXP (x11, 0);
              operands[2] = x12;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 11443 "../../gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 11445 "../../gcc/config/arm/arm.md"
( reload_completed)))
                return NULL;
              return gen_split_97 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          operands[4] = x4;
          operands[3] = x6;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode))
            return NULL;
          x11 = XEXP (x2, 2);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 11407 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && !TARGET_COND_ARITH) && 
#line 11409 "../../gcc/config/arm/arm.md"
( reload_completed)))
            return NULL;
          return gen_split_96 (insn, operands);

        default:
          return NULL;
        }

    case CTZ:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !(
#line 12213 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2) && 
#line 12215 "../../gcc/config/arm/arm.md"
( reload_completed)))
        return NULL;
      return gen_split_104 (insn, operands);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 100)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      switch (GET_MODE (x3))
        {
        case E_CCFPmode:
          switch (pattern362 (x2, 
E_CCFPmode))
            {
            case 0:
              if (!
#line 1751 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return NULL;
              return gen_split_107 (insn, operands);

            case 1:
              if (!
#line 1781 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return NULL;
              return gen_split_109 (insn, operands);

            default:
              return NULL;
            }

        case E_CCFPEmode:
          switch (pattern362 (x2, 
E_CCFPEmode))
            {
            case 0:
              if (!
#line 1766 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return NULL;
              return gen_split_108 (insn, operands);

            case 1:
              if (!
#line 1796 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return NULL;
              return gen_split_110 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x11 = XEXP (x2, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 220 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return NULL;
      return gen_split_115 (insn, operands);

    case VEC_CONCAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          if (!(
#line 3649 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!(
#line 3649 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_167 (insn, operands);

        case 2:
          if (!(
#line 3649 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_168 (insn, operands);

        case 3:
          if (!(
#line 3649 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_169 (insn, operands);

        case 4:
          if (!(
#line 3649 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_170 (insn, operands);

        case 5:
          if (!(
#line 3649 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_171 (insn, operands);

        case 6:
          if (!(
#line 3649 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 3651 "../../gcc/config/arm/neon.md"
( reload_completed)))
            return NULL;
          return gen_split_172 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      if (GET_MODE (x2) != E_V2DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V2DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!neon_struct_operand (operands[1], E_DImode)
          || !(
#line 5204 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 5206 "../../gcc/config/arm/neon.md"
( reload_completed)))
        return NULL;
      return gen_split_176 (insn, operands);

    default:
      return NULL;
    }
}
